/** SGX

The   sss    gggg x   x   
     s      g      x x    Engine
      sss   g  gg   x
         s  g   g  x x          Copyright 1995-2008.
     ssss    gggg x   x         Steven Goodwin. All Rights Reserved.
    
This version has been released under the GNU Public License v2.0.

Please see the license files for details.

File: include/drivers/wintel32/audio/fmodsoundengine.hpp

*/

#ifndef SGX_FMOD_AUDIO_SOUND_ENGINE_HPP
#define SGX_FMOD_AUDIO_SOUND_ENGINE_HPP	1

class CFMODSoundEngine : public CSGXAudioEngine
{
public:
	static CSGXAudioEngine *create();
	virtual ~CFMODSoundEngine();

	virtual void			initialize();
	virtual void			release();
	virtual CSampleData *	createSample(const sgxString &filename, const CSGXAudioEngine::ResourceContext context=eDefault);
	virtual void			prepareLogicalChannels(tUINT32 numChannels);
	virtual void			updateHardwareMixer(tREAL32 time_elapsed);
	virtual void			suspendEngine();
	virtual void			resumeEngine();

private:
	FMOD_SYSTEM	*			m_System;
	CFMODDeviceChannel **	m_pDeviceChannel;

	friend CFMODSampleData;
};

#endif /* SGX_FMOD_AUDIO_SOUND_ENGINE_HPP */
